Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class EarlyEvaluationContext

    java.lang.Object
      net.sf.saxon.expr.EarlyEvaluationContext

All Implemented Interfaces:
  Serializable, XPathContext

    public class EarlyEvaluationContext

extends Object
implements XPathContext, Serializable

This class is an implementation of XPathContext used when evaluating constant sub-expressions at compile time.

See Also:
  Serialized Form

Constructor Summary
`EarlyEvaluationContext(Configuration config, CollationMap map)` Create an early evaluation context, used for evaluating constant expressions at compile time

Method Summary
`void` | `changeOutputDestination(Receiver receiver, boolean isFinal, int validation, SchemaType schemaType)` Set a new output destination, supplying the output format details.
`ValueRepresentation` | `evaluateLocalVariable(int slotnumber)` Get the value of a local variable, identified by its slot number
`XPathContext` | `getCaller()` Get the calling XPathContext (the next one down the stack).
`StringCollator` | `getCollation(String name)` Get a named collation
`Configuration` | `getConfiguration()` Get the Configuration
`Item` | `getContextItem()` Get the context item
`int` | `getContextPosition()` Get the context position (the position of the context item)
`Controller` | `getController()` Get the Controller.
`DateTimeValue` | `getCurrentDateTime()` Get the current date and time.
`XPathException` | `getCurrentException()` Get the current exception (in saxon:catch)
`GroupIterator` | `getCurrentGroupIterator()` Get the current group iterator.
`SequenceIterator` | `getCurrentIterator()` Get the current iterator.
`Mode` | `getCurrentMode()` Get the current mode.
`RegexIterator` | `getCurrentRegexIterator()` Get the current regex iterator.
`Rule` | `getCurrentTemplateRule()` Get the current template.
`int` | `getImplicitTimezone()` Get the implicit timezone, as a positive or negative offset from UTC in minutes.
`int` | `getLast()` Get the context size (the position of the last item in the current node list)
`ParameterSet` | `getLocalParameters()` Get the local (non-tunnel) parameters that were passed to the current function or template
`NamePool` | `getNamePool()` Get the Name Pool
`InstructionInfo` | `getOrigin()` Get information about the creating expression or other construct.
`int` | `getOriginatingConstructType()` Get the type of location from which this context was created.
`SequenceReceiver` | `getReceiver()` Get the Receiver to which output is currently being written.
`StackFrame` | `getStackFrame()` Get a reference to the local stack frame for variables.
`ParameterSet` | `getTunnelParameters()` Get the tunnel parameters that were passed to the current function or template.
`boolean` | `isAtLast()` Determine whether the context position is the same as the context size that is, whether position()=last()
`Iterator` | `iterateStackFrames()` Get the context stack.
`XPathContextMajor` | `newCleanContext()` Construct a new context without copying (used for the context in a function call)
`XPathContextMajor` | `newContext()` Construct a new context as a copy of another.
`XPathContextMinor` | `newMinorContext()` Construct a new minor context.
`void` | `setCaller(XPathContext caller)` Set the calling XPathContext
`void` | `setCurrentIterator(SequenceIterator iter)` Set a new sequence iterator.
`void` | `setLocalVariable(int slotnumber, ValueRepresentation value)` Set the value of a local variable, identified by its slot number
`void` | `setOrigin(InstructionInfo expr)` Set the creating expression (for use in diagnostics).
`void` | `setOriginatingConstructType(int loc)` Set the type of creating expression (for use in diagnostics).
`void` | `setReceiver(SequenceReceiver receiver)` Change the Receiver to which output is written
`void` | `setTemporaryReceiver(SequenceReceiver out)` Set the receiver to which output is to be written, marking it as a temporary (non-final) output destination.
`int` | `useLocalParameter(StructuredQName qName, LocalParam binding, boolean isTunnel)` Use local parameter.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### EarlyEvaluationContext

    public EarlyEvaluationContext(Configuration config,
                                  CollationMap map)

  Create an early evaluation context, used for evaluating constant expressions at compile time

  Parameters:
    `config` - the Saxon configuration
    `map` - the available collations

Method Detail

### changeOutputDestination

    public void changeOutputDestination(Receiver receiver,
                                        boolean isFinal,
                                        int validation,
                                        SchemaType schemaType)
                                 throws XPathException

  Set a new output destination, supplying the output format details.
  Note that it is the caller's responsibility to close the Writer after use.

  Specified by:
    `changeOutputDestination` in interface `XPathContext`
  Parameters:
    `isFinal` - true if the destination is a final result tree (either the principal output or a secondary result tree); false if it is a temporary tree, xsl:attribute, etc.
    `validation` - validation mode: strict, lax, preserve, or strip
    `schemaType` - type against which the output must be validated
  Throws:
    `XPathException` - if any dynamic error occurs; and specifically, if an attempt is made to switch to a final output destination while writing a temporary tree or sequence

### evaluateLocalVariable

    public ValueRepresentation evaluateLocalVariable(int slotnumber)

  Get the value of a local variable, identified by its slot number

  Specified by:
    `evaluateLocalVariable` in interface `XPathContext`
  Parameters:
    `slotnumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
  Returns:
    the value of the variable.

### getCaller

    public XPathContext getCaller()

  Get the calling XPathContext (the next one down the stack). This will be null if unknown, or if the bottom of the stack has been reached.

  Specified by:
    `getCaller` in interface `XPathContext`
  Returns:
    the XPathContext of the calling expression

### getCollation

    public StringCollator getCollation(String name)
                                throws XPathException

  Get a named collation

  Specified by:
    `getCollation` in interface `XPathContext`
  Parameters:
    `name` - the name (URI) of the required collation
  Returns:
    a StringCollator representing the collation
  Throws:
    `XPathException` - if the collation is not recognized

### getConfiguration

    public Configuration getConfiguration()

  Get the Configuration

  Specified by:
    `getConfiguration` in interface `XPathContext`
  Returns:
    the Saxon configuration object

### getContextItem

    public Item getContextItem()

  Get the context item

  Specified by:
    `getContextItem` in interface `XPathContext`
  Returns:
    the context item, or null if the context item is undefined

### getContextPosition

    public int getContextPosition()
                           throws XPathException

  Get the context position (the position of the context item)

  Specified by:
    `getContextPosition` in interface `XPathContext`
  Returns:
    the context position (starting at one)
  Throws:
    `XPathException` - if the context position is undefined

### getController

    public Controller getController()

  Get the Controller. May return null when running outside XSLT or XQuery

  Specified by:
    `getController` in interface `XPathContext`
  Returns:
    the controller for this query or transformation

### getCurrentGroupIterator

    public GroupIterator getCurrentGroupIterator()

  Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0

  Specified by:
    `getCurrentGroupIterator` in interface `XPathContext`
  Returns:
    the current grouped collection

### getCurrentIterator

    public SequenceIterator getCurrentIterator()

  Get the current iterator. This encapsulates the context item, context position, and context size.

  Specified by:
    `getCurrentIterator` in interface `XPathContext`
  Returns:
    the current iterator, or null if there is no current iterator (which means the context item, position, and size are undefined).

### getCurrentMode

    public Mode getCurrentMode()

  Get the current mode.

  Specified by:
    `getCurrentMode` in interface `XPathContext`
  Returns:
    the current mode

### getCurrentRegexIterator

    public RegexIterator getCurrentRegexIterator()

  Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.

  Specified by:
    `getCurrentRegexIterator` in interface `XPathContext`
  Returns:
    the current regular expressions iterator

### getCurrentTemplateRule

    public Rule getCurrentTemplateRule()

  Get the current template. This is used to support xsl:apply-imports

  Specified by:
    `getCurrentTemplateRule` in interface `XPathContext`
  Returns:
    the current template

### getLast

    public int getLast()
                throws XPathException

  Get the context size (the position of the last item in the current node list)

  Specified by:
    `getLast` in interface `XPathContext`
  Returns:
    the context size
  Throws:
    `XPathException` - if the context position is undefined

### getLocalParameters

    public ParameterSet getLocalParameters()

  Get the local (non-tunnel) parameters that were passed to the current function or template

  Specified by:
    `getLocalParameters` in interface `XPathContext`
  Returns:
    a ParameterSet containing the local parameters

### getNamePool

    public NamePool getNamePool()

  Get the Name Pool

  Specified by:
    `getNamePool` in interface `XPathContext`
  Returns:
    the name pool

### getOrigin

    public InstructionInfo getOrigin()

  Get information about the creating expression or other construct.

  Specified by:
    `getOrigin` in interface `XPathContext`
  Returns:
    information about the creating expression

### getOriginatingConstructType

    public int getOriginatingConstructType()

  Get the type of location from which this context was created.

  Specified by:
    `getOriginatingConstructType` in interface `XPathContext`
  Returns:
    the type of location. (The integer codes that are used are often fingerprints of instruction names, but not always. For details of the codes, see the standard trace listener which interprets them)

### getReceiver

    public SequenceReceiver getReceiver()

  Get the Receiver to which output is currently being written.

  Specified by:
    `getReceiver` in interface `XPathContext`
  Returns:
    the current Receiver

### getStackFrame

    public StackFrame getStackFrame()

  Get a reference to the local stack frame for variables. Note that it's the caller's job to make a local copy of this. This is used for creating a Closure containing a retained copy of the variables for delayed evaluation.

  Specified by:
    `getStackFrame` in interface `XPathContext`
  Returns:
    array of variables.

### getTunnelParameters

    public ParameterSet getTunnelParameters()

  Get the tunnel parameters that were passed to the current function or template. This includes all active tunnel parameters whether the current template uses them or not.

  Specified by:
    `getTunnelParameters` in interface `XPathContext`
  Returns:
    a ParameterSet containing the tunnel parameters

### isAtLast

    public boolean isAtLast()
                     throws XPathException

  Determine whether the context position is the same as the context size that is, whether position()=last()

  Specified by:
    `isAtLast` in interface `XPathContext`
  Returns:
    true if the context position is the same as the context size.
  Throws:
    `XPathException`

### newCleanContext

    public XPathContextMajor newCleanContext()

  Construct a new context without copying (used for the context in a function call)

  Specified by:
    `newCleanContext` in interface `XPathContext`
  Returns:
    a new clean context

### newContext

    public XPathContextMajor newContext()

  Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context

  Specified by:
    `newContext` in interface `XPathContext`
  Returns:
    a new context, created as a copy of this context

### newMinorContext

    public XPathContextMinor newMinorContext()

  Construct a new minor context. A minor context can only hold new values of the focus (currentIterator) and current output destination.

  Specified by:
    `newMinorContext` in interface `XPathContext`
  Returns:
    a new minor context

### setCaller

    public void setCaller(XPathContext caller)

  Set the calling XPathContext

  Specified by:
    `setCaller` in interface `XPathContext`
  Parameters:
    `caller` - the XPathContext of the calling expression

### setCurrentIterator

    public void setCurrentIterator(SequenceIterator iter)

  Set a new sequence iterator.

  Specified by:
    `setCurrentIterator` in interface `XPathContext`
  Parameters:
    `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

### setLocalVariable

    public void setLocalVariable(int slotnumber,
                                 ValueRepresentation value)

  Set the value of a local variable, identified by its slot number

  Specified by:
    `setLocalVariable` in interface `XPathContext`
  Parameters:
    `slotnumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
    `value` - the value of the variable

### setOrigin

    public void setOrigin(InstructionInfo expr)

  Set the creating expression (for use in diagnostics). The origin is generally set to "this" by the object that creates the new context. It's up to the debugger to determine whether this information is useful. Where possible, the object will be an `Expression`, allowing information about the calling instruction to be obtained.

  Specified by:
    `setOrigin` in interface `XPathContext`
  Parameters:
    `expr` - the expression that created this context object

### setOriginatingConstructType

    public void setOriginatingConstructType(int loc)

  Set the type of creating expression (for use in diagnostics). When a new context is created, either this method or `XPathContext.setOrigin(net.sf.saxon.trace.InstructionInfo)` should be called.

  Specified by:
    `setOriginatingConstructType` in interface `XPathContext`
  Parameters:
    `loc` - The originating location: the argument must be one of the integer constants in class `Location`

### setReceiver

    public void setReceiver(SequenceReceiver receiver)

  Change the Receiver to which output is written

  Specified by:
    `setReceiver` in interface `XPathContext`
  Parameters:
    `receiver` - the SequenceReceiver to be used

### setTemporaryReceiver

    public void setTemporaryReceiver(SequenceReceiver out)

  Set the receiver to which output is to be written, marking it as a temporary (non-final) output destination.

  Specified by:
    `setTemporaryReceiver` in interface `XPathContext`
  Parameters:
    `out` - The SequenceOutputter to be used

### useLocalParameter

    public int useLocalParameter(StructuredQName qName,
                                 LocalParam binding,
                                 boolean isTunnel)
                          throws XPathException

  Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated

  Specified by:
    `useLocalParameter` in interface `XPathContext`
  Parameters:
    `qName` - The fingerprint of the parameter name
    `binding` - The XSLParam element to bind its value to
    `isTunnel` - True if a tunnel parameter is required, else false
  Returns:
    true if a parameter of this name was supplied, false if not
  Throws:
    `XPathException`

### getCurrentDateTime

    public DateTimeValue getCurrentDateTime()
                                     throws NoDynamicContextException

  Get the current date and time. This implementation always throws a NoDynamicContextException.

  Specified by:
    `getCurrentDateTime` in interface `XPathContext`
  Returns:
    the current date and time. All calls within a single query or transformation will return the same value
  Throws:
    `NoDynamicContextException`

### getImplicitTimezone

    public int getImplicitTimezone()
                            throws NoDynamicContextException

  Get the implicit timezone, as a positive or negative offset from UTC in minutes. The range is -14hours to +14hours. This implementation always throws a NoDynamicContextException.

  Specified by:
    `getImplicitTimezone` in interface `XPathContext`
  Returns:
    the implicit timezone, as an offset from UTC in minutes
  Throws:
    `NoDynamicContextException`

### iterateStackFrames

    public Iterator iterateStackFrames()

  Get the context stack. This method returns an iterator whose items are instances of `ContextStackFrame`, starting with the top-most stackframe and ending at the point the query or transformation was invoked by a calling application.

  Specified by:
    `iterateStackFrames` in interface `XPathContext`
  Returns:
    an iterator over a copy of the run-time call stack

### getCurrentException

    public XPathException getCurrentException()

  Get the current exception (in saxon:catch)

  Specified by:
    `getCurrentException` in interface `XPathContext`
  Returns:
    the current exception, or null if there is none defined

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.